## Patch the Archetypes FileField so that it returns a
## tramline header when downloaded so tramline knows
## to intercept it and send the file

from Products.Archetypes.debug import log
from Products.Archetypes.utils import contentDispositionHeader
import os

REPOSITORY_PATH = "/home/zope/tramline_data"


#security.declareProtected(CMFCorePermissions.View, 'download')
def download(self, instance, REQUEST=None, RESPONSE=None):
    """Kicks download.

    Writes data including file name and content type to RESPONSE
    """
    file = self.get(instance)
    if not REQUEST:
        REQUEST = instance.REQUEST
    if not RESPONSE:
        RESPONSE = REQUEST.RESPONSE
    filename = self.getFilename(instance)
    if filename is not None:
        header_value = contentDispositionHeader('attachment', instance.getCharset(), filename=filename)
        RESPONSE.setHeader("Content-disposition", header_value)
        RESPONSE.setHeader("tramline_file", "ok")
    return file.index_html(REQUEST, RESPONSE)

from Products.Archetypes.Field import FileField
FileField.download = download

log("NOTICE: patched Archetypes.Field.FileField.download for tramline")

FileField.orig_get_size = FileField.get_size
def get_size(self, instance):
    """Get size of the stored data used for get_size in BaseObject
    """
    file = self.get(instance)
    tramline_id = str(file)

    try:
        size = os.stat(REPOSITORY_PATH+'/repository/'+tramline_id)[6]
        return size
    except OSError:
        # Try the uploads as this may be a new file and not yet moved
        # to the repository
        try:
            size = os.stat(REPOSITORY_PATH+'/upload/'+tramline_id)[6]
            return size
        except OSError:
            pass

        # We can't find the object, so use the original get_size method
        # this is a safe fallback in case you aren't really using tramline
        # for this object
        return self.orig_get_size(instance)

FileField.get_size = get_size

log("NOTICE: patched Archetypes.Field.FileField.get_size for tramline")


